
TIME_robel <- function(mname='Phi()P()TIME',theta_init=NULL) {

LOGLIK00 <- function(theta1) { t00=Sys.time()[1]; theta=thta.fn(theta1)
  thet_beta<-matrix(0,nrow=NS,ncol=max(NT)); i=0
  for (ss in 1:NS) {
    thet_beta[ss,1:NT[ss]]=invlogitgen(theta[i+1:(NT[ss]-1)])
    i=i+NT[ss]-1
  }
  thet_phi_site     =theta[i+1:NS]
  i=i+NS+1; thet_phi_Stage  =theta[i]
  i=i+1; thet_phi_Cattle  =theta[i]
  i=i+1; thet_phi_Robel  =theta[i]
  thet_p_site    =theta[i+1:NS]
  i=i+NS+1; thet_p_Stage    =theta[i]
  i=i+1; thet_p_Cattle  =theta[i]
  i=i+1; thet_p_Robel  =theta[i]
  thet_N          =CC+exp(theta[i+1:NS])
  i=i+NS; thet_pi_Cattle  =plogis(theta[i+1:NS])
  i=i+NS+1; thet_moy_Robel=theta[i]
  i=i+1; thet_sd_Robel=abs(theta[i])

  ### Compute probability of capture-recapture data  (Pdata)
  #--------------------------------------------------
  Pdata<-ll00(theta1)
  #t1a<<-t1a+system.time(Pdata<-ll00(theta1))[1]
  ### Probability of missing a carcass (Gauss Hermite quadrature)
  #--------------------------------------------------
  thet=list(beta=thet_beta,
     phi_site=thet_phi_site,phi_Stage=thet_phi_Stage,
     phi_Cattle=thet_phi_Cattle,phi_Robel=thet_phi_Robel,
     p_site=thet_p_site,p_Stage=thet_p_Stage,
     p_Cattle=thet_p_Cattle, p_Robel=thet_p_Robel,
     N=thet_N,pi_Cattle=thet_pi_Cattle,
     moy_Robel=thet_moy_Robel, sd_Robel=thet_sd_Robel)
  P0<-compute_P0(thet)

  logLIK=Pdata-sum(lfactorial(thet_N)-lfactorial(thet_N-CC)+(thet_N-CC)*log(P0))

  setTkProgressBar(pb,value=iternum,label=paste("Optimization2...",iternum,
     round(logLIK,3),"\nP0=", paste(round(P0,3),collapse=' '), "\nN=",
     paste(round(thet_N,2),collapse=' ')))

  return(logLIK)

}  # end definition LOGLIKsPs

ll00 <- function(theta1) {
  theta=thta.fn(theta1); Pdata=i=0; thet_beta<-matrix(0,nrow=NS,ncol=max(NT))
  for (ss in 1:NS) {
    thet_beta[ss,1:NT[ss]]=invlogitgen(theta[i+1:(NT[ss]-1)])
    i=i+NT[ss]-1
  }
  thet_phi_site=theta[i+1:NS]; i=i+NS+1;
  thet_phi_Stage=theta[i]; thet_phi_Cattle=theta[i+1]; thet_phi_Robel=theta[i+2]
  i=i+2; thet_p_site=theta[i+1:NS]; i=i+NS+1;
  thet_p_Stage=theta[i]; thet_p_Cattle=theta[i+1]; thet_p_Robel=theta[i+2]
  i=i+2; thet_N=CC+exp(theta[i+1:NS])
  i=i+NS; thet_pi_Cattle  =plogis(theta[i+1:NS])
  i=i+NS+1; thet_moy_Robel=theta[i]; thet_sd_Robel=abs(theta[i+1])

  # initiate matrices
  thet_phiDaily=rep(0,daymax); thet_p=rep(0,max(NT)); thet_phi=rep(0,max(NT)-1)

  ### Compute probability of capture-recapture data  (Pdata)
  #--------------------------------------------------
  t2=rep(0,length(robel.data))
  if (ContCovCol>0) t2=log(dnorm(robel.data,thet_moy_Robel,thet_sd_Robel))
  for ( k in 1:C1) {     # loop over individuals
    sitek=Site[k]; TT=NT[sitek]; Lday <- DaySampl[sitek,NT[sitek]] ## Last day of study for this site
    FF=xdata$FirstFound[k]; LP=xdata$LastPresent[k] ; AF = xdata$AgeFound[k]
    # Daily survival
    t=ek[k]:Lday  ## GP290713
    thet_phiDaily=plogis(thet_phi_site[sitek]+
      thet_phi_Stage*(t>=DayStartIncub[k])+
      thet_phi_Cattle*cattle.data[k]+
      thet_phi_Robel*robel.data[k])
    # Detection
    t=1:NT[sitek]; thet_p[t] = plogis(thet_p_site[sitek] +
      thet_p_Stage*(t<psik[k])+
      thet_p_Cattle*cattle.data[k]+
      thet_p_Robel*robel.data[k])
    ## Probability of detecting nest on fk[k]th visit
    if(AF<=1) Pfk=thet_p[fk[k]] else Pfk=prod(thet_phiDaily[1:(AF-1)])*thet_p[fk[k]] ## GP290713
    if (fk[k] > bk[k]) Pfk=Pfk*prod(1-thet_p[bk[k]:(fk[k]-1)])
    ## Probability of nest survival data
    ###1 if successful nest or fails after last occ
    if (xdata$Fate[k] == 0 || xdata$LastPresent[k]>=Lday) {
        PSk <- prod(thet_phiDaily[AF:(min(Hk[k],Lday)-ek[k])])
    } else {
    ###2 if failed nest
      llast <- min(Hk[k], LP, Lday)
      llast2<-lastocc(llast,sitek)
      if (llast2<NT[sitek]) {
        d1=DaySampl[sitek,llast2];
        d2=max(d1,DaySampl[sitek,(llast2+1)]-1)
        thet_phi = prod(thet_phiDaily[d1:d2-ek[k]+1])   ## GP290713
        PSk=1-thet_phi
      } else {PSk=1} # GP20082013
      if (llast>FF) {
        PSk=PSk*prod(thet_phiDaily[AF:(llast-ek[k])]);
      }
    }
    t1=log(thet_pi_Cattle[sitek]*cattle.data[k]+(1-thet_pi_Cattle[sitek])*(1-cattle.data[k]))
    Pdata <- Pdata - log(Pfk) - log(PSk)- log(thet_beta[sitek,bk[k]])- t1 - t2[k]
  }  # end loop on individual nests
  logLIK=Pdata;
  iternum<<-iternum+1 ;
  if (disp.pb)
    setTkProgressBar(pb,value=iternum,label=paste("Optimization1...",iternum,round(logLIK,3)))
  return(logLIK)
}  # end definition LOGLIKsPs

#########################################
# P0
#########################################
#-- When fixing continuous cov to its mean  [returns a NS size vector]
### NB: if there is no use of the continuous cov (Robel),
### then use only this function to compute P0 divides computation time by Q)
compute_P0MOY<- function(thet) {
  P0=NULL;   r=thet$moy_Robel
  for (s in 1:NS) {  Q0=0
    for (uu in 1:NT[s]) {
              #-- P0i: Fixed entry occasion, site, and cov values (c and r)
      if(uu>1){Duri=DaySampl[s,uu]-DaySampl[s,uu-1]} else{Duri=INCUBLEN}
      AAA=1:Duri-1
      Pra0 <-plogis(thet$phi_site[s]+thet$phi_Stage*(AAA>=AvgClutch)+
                    thet$phi_Robel*r)^AAA
      Pra0=Pra0/sum(Pra0)
      Pra1 <-plogis(thet$phi_site[s]+thet$phi_Stage*(AAA>=AvgClutch)+
                    thet$phi_Cattle+thet$phi_Robel*r)^AAA
      Pra1=Pra1/sum(Pra1)
      P0i0=P0i1=0
      for (a in AAA) {
        P0i0=P0i0+P0ia(thet,uu,a,s,0,r)*Pra0[a+1]
        P0i1=P0i1+P0ia(thet,uu,a,s,1,r)*Pra1[a+1]
      }
      #tmp=thet$pi_Cattle[s]*  P0i(thet,uu,s,1,thet$moy_Robel)+
      #  (1-thet$pi_Cattle[s])*P0i(thet,uu,s,0,thet$moy_Robel)
      tmp=thet$pi_Cattle[s]*  P0i1 + (1-thet$pi_Cattle[s])*P0i0
      Q0=Q0+thet$beta[s,uu]*tmp
    }
    P0=c(P0,min(Q0,1))
  }
  return(P0)
}
#-- When integrating over cov values (GH quad) [returns a NS size vector]
compute_P0INT<- function(thet) {
  P0=NULL
  for (s in 1:NS) { Q0=0
    for (q in 1:Q) {
      r=thet$sd_Robel*sqrt(2)*zGH[q]+thet$moy_Robel
      for (uu in 1:NT[s]) {
                   #-- P0i: Fixed entry occasion, site, and cov values (c and r)
        if(uu>1){Duri=DaySampl[s,uu]-DaySampl[s,uu-1]} else{Duri=INCUBLEN}
        AAA=1:Duri-1
        Pra0 <-plogis(thet$phi_site[s]+thet$phi_Stage*(AAA>=AvgClutch)+
                      thet$phi_Robel*r)^AAA
        Pra0=Pra0/sum(Pra0)
        Pra1 <-plogis(thet$phi_site[s]+thet$phi_Stage*(AAA>=AvgClutch)+
                      thet$phi_Cattle+thet$phi_Robel*r)^AAA
        Pra1=Pra1/sum(Pra1)
        P0i0=P0i1=0
        for (a in AAA) {
          P0i0=P0i0+P0ia(thet,uu,a,s,0,r)*Pra0[a+1]
          P0i1=P0i1+P0ia(thet,uu,a,s,1,r)*Pra1[a+1]
        }
        #tmp=thet$pi_Cattle[s]*  P0i(thet,uu,s,1,thet$sd_Robel*sqrt(2)*zGH[q]+thet$moy_Robel)+
        #  (1-thet$pi_Cattle[s])*P0i(thet,uu,s,0,thet$sd_Robel*sqrt(2)*zGH[q]+thet$moy_Robel)
        tmp=thet$pi_Cattle[s]*  P0i1 + (1-thet$pi_Cattle[s])*P0i0
        Q0=Q0+thet$beta[s,uu]*wGH[q]*tmp
      }
    }
    P0=c(P0,min(Q0/sqrt(3.14159265),1))
  }
  return(P0)
}

#-- Fixed entry occasion, age at entry, site, and cov values (c and r)
P0ia<- function(thet,uu,a,s,c,r) {
  HatchDate= DaySampl[s,uu]-a+INCUBLEN  # expected hatch date =34 in paper
  DayStartIncub1 = DaySampl[s,uu]-a + AvgClutch # expected start of incubation
  InitDate=max(DaySampl[s,uu]-a,1)  # initiation date or start of study
  psi = lastocc(DayStartIncub1,s) # last occasion before incubation start
  Lday <- DaySampl[s,NT[s]]
  HatchDate2 <- min(HatchDate,Lday)

  #Q0=P0iaSucc(thet,uu,a,s,c,r)
  d=HatchDate2
  t=uu:lastocc(d,s)
  thet_p = plogis(thet$p_site[s] + thet$p_Stage*(t<psi) +
                  thet$p_Cattle*c + thet$p_Robel*r)
  # Daily survival
  t=DaySampl[s,uu]:(d-1)
  thet_phiDaily = plogis(thet$phi_site[s] + thet$phi_Stage*(t>=DayStartIncub1)+
    thet$phi_Cattle*c+thet$phi_Robel*r)
  tmp=d>DaySampl[s,uu]
  prphi<- tmp*prod(thet_phiDaily) +1-tmp
  phid<- thet_phiDaily[length(thet_phiDaily)]
  Q0=prod(1-thet_p)*prphi

  for (d in DaySampl[s,uu]:HatchDate2) {
    #Q0=Q0+P0iad(thet,uu,a,d,s,c,r)
    t=uu:lastocc(d,s)    # Detection
    thet_p = plogis(thet$p_site[s] + thet$p_Stage*(t<psi) +
                    thet$p_Cattle*c + thet$p_Robel*r)
    t=DaySampl[s,uu]:d     # Daily survival
    thet_phiDaily = plogis(thet$phi_site[s] + thet$phi_Stage*(t>=DayStartIncub1)+
                           thet$phi_Cattle*c+thet$phi_Robel*r)
    ll=length(thet_phiDaily); tmp=ll>1
    prphi<- tmp*prod(thet_phiDaily[1:max((ll-1),1)]) +1-tmp
    phid<- thet_phiDaily[length(thet_phiDaily)]
    Q0=Q0+(prod(1-thet_p)*prphi*(1-phid))
  }
  return(Q0)
}
######################################################
t1a=t1b=0;
v1<-NULL; for(s in 1:NS) v1<-c(v1,paste(s,' time',1:(NT[s]-1),sep=''))
v1<-c(
  paste("Entry site",v1),
  paste("Survival: site",1:NS),
  "Survival: Stage",
  "Survival: Cattle",
  "Survival: Robel",
  paste("Detection: site",1:NS),
  "Detection: Stage" ,
  "Detection: Cattle",
  "Detection: Robel",
  paste('Superpop. size:Site',1:NS),
  paste("Prop. Cattle site",1:NS),
  "moy Robel", "sd Robel"
  )
v2<-NULL; for(s in 1:NS) v2=c(v2,paste(s,' time',1:(NT[s]),sep=''))
v2<-c(
  paste("Entry site",v2),
  paste("Survival:Egg:Site:NoCattle",1:NS),
  paste("Survival:Incub:Site:NoCattle",1:NS),
  paste("Survival:Egg:Site:Cattle",1:NS),
  paste("Survival:Incub:Site:Cattle",1:NS),
  paste("Detection:Egg:Site:NoCattle",1:NS),
  paste("Detection:Incub:Site:NoCattle",1:NS),
  paste("Detection:Egg:Site:Cattle",1:NS),
  paste("Detection:Incub:Site:Cattle",1:NS),
  paste('Superpop.size:Site',1:NS),
  paste('P0:Site',1:NS),
  "Survival:Robel","Detection:Robel"
  )
  if (nchar(BinCovName)>0) { v1=gsub("Cattle",BinCovName,v1); v2=gsub("Cattle",BinCovName,v2)}
  if (nchar(ContCovName)>0) { v1=gsub("Robel",ContCovName,v1); v2=gsub("Robel",ContCovName,v2)}
  iternum<<-0 ; opt.fn<<-0; maxitr=3000
  x=table(xdata$Site,xdata$Site); if (BinCovCol>0) x=table(cattle.data,xdata$Site)
  v=qlogis(x[2,]/colSums(x));  v[v<(-40)]=-40; v[v>40]=40;

  #mname2pim(mname,v1)

  l= length(v1);   pim<<-1:l; fixed<<-rep(NA,l)
  s=gsub('.+[(]','',unlist(strsplit(mname,')'))); k=sum(NT)-NS
  if (length(grep('site',  s[1]))<1)   pim[k+2:NS]<<-pim[k+1]
  if (length(grep('stage', s[1]))<1) { pim[k+NS+1]<<-1; fixed[k+NS+1]<<-0 }
  i=max(pim[1:k+NS+1])+1
  if (length(grep(BinCovName,s[1]))<1 || nchar(BinCovName)<1) { pim[k+NS+2]<<-1; fixed[k+NS+2]<<-0 }
  if (length(grep(ContCovName,s[1]))<1 || nchar(ContCovName)<1) { pim[k+NS+3]<<-1; fixed[k+NS+3]<<-0 }
  k=k+NS+3
  if (length(grep('site',  s[2]))<1)   pim[k+2:NS]<<-pim[k+1]
  if (length(grep('stage', s[2]))<1) { pim[k+NS+1]<<-1; fixed[k+NS+1]<<-0 }
  if (length(grep(BinCovName,s[2]))<1 || nchar(BinCovName)<1) { pim[k+NS+2]<<-1; fixed[k+NS+2]<<-0 }
  if (length(grep(ContCovName,s[2]))<1 || nchar(ContCovName)<1) { pim[k+NS+3]<<-1; fixed[k+NS+3]<<-0 }
  k=as.numeric(levels(as.factor(pim)))   # renumber pim
  newpim=pim; for (i in 1:length(pim)) newpim[pim==k[i]]=i; pim<<-newpim
##
  if (BinCovCol<1) {   #  if no cattle in data, fix params prop.cattle.site.n
    pim[(l-NS-1):(l-2)]<<-1; fixed[(l-NS-1):(l-2)]<<-rep(qlogis(1/NS),NS)
  }
  if (ContCovCol<1) {   #  if no robel in data, fix params moy_Robel, sd_Robel
    pim[(l-1):l]<<-1; fixed[(l-1):l]<<-c(mean(robel.data),sd(robel.data))
  }

  l=max(pim); pb=tkProgressBar(mname,min=1,max=3000)

  if (is.null(theta_init)) {
    theta_init = rep(0,l)
  }  else {
    theta_init = thta.fn.inv(theta_init)  #  init values must have length=v1
  }
  theta_init[is.na(theta_init)]=0; l=length(theta_init)
  if (theta_init[l]==0 && ContCovCol>0) {
    theta_init[l-1]<-mean(robel.data); theta_init[l]<-sd(robel.data)
  }
  ll=length(v1)-2-NS
  if (thta.fn(theta_init)[ll+1]==0) {
    theta_init[pim[ll+1:NS]]=v  ;
  }

  x=cbind(v1,pim,fixed,thta.fn(theta_init));
  dimnames(x)=list(NULL,c('parm','pim','fixed','init.val'));
  print(x,quote=F); cat('\nRunning optimization...\n')
  iternum<<-0 ; disp.pb<<-1
##
  l=max(pim); iternum<<-0

  t0=system.time(s0<-nlm(ll00,theta_init, hessian = FALSE,iterlim=1000))

  compute_P0<-compute_P0MOY; iternum<<-0; disp.pb<<-0

  t1=system.time(ssMOY <- nlm (LOGLIK00,s0$estimate, hessian = TRUE,iterlim=2))

  ss1=ssMOY; t2=0; tMOY<-ssMOY$estimate;
  if (length(grep('robel',mname))>0) {
    compute_P0<-compute_P0INT
    iternum<<-0; opt.fn<<-2
    t2=system.time(ss1 <- nlm(LOGLIK00,tMOY, hessian = TRUE,iterlim=maxitr))
  }
  close(pb)

  thetaM=ss1$estimate; theta=thta.fn(thetaM); l=length(thetaM)
# Compute transformed estimates
  thet_beta<-matrix(0,nrow=NS,ncol=max(NT));i=0
  for (ss in 1:NS) {
    thet_beta[ss,1:NT[ss]]=invlogitgen(theta[i+1:(NT[ss]-1)])
    i=i+NT[ss]-1
  }
  thet_phi_site     =theta[i+1:NS]
  i=i+NS+1; thet_phi_Stage  =theta[i]
  i=i+1; thet_phi_Cattle  =theta[i]
  i=i+1; thet_phi_Robel  =theta[i]
  thet_p_site    =theta[i+1:NS]
  i=i+NS+1; thet_p_Stage    =theta[i]
  i=i+1; thet_p_Cattle  =theta[i]
  i=i+1; thet_p_Robel  =theta[i]
  thet_N          =CC+exp(theta[i+1:NS])
  i=i+NS; thet_pi_Cattle  =plogis(theta[i+1:NS])
  i=i+NS+1; thet_moy_Robel=theta[i]
  i=i+1; thet_sd_Robel=abs(theta[i])
  thet=list(beta=thet_beta,
     phi_site=thet_phi_site,phi_Stage=thet_phi_Stage,
     phi_Cattle=thet_phi_Cattle,phi_Robel=thet_phi_Robel,
     p_site=thet_p_site,p_Stage=thet_p_Stage,
     p_Cattle=thet_p_Cattle, p_Robel=thet_p_Robel,
     N=thet_N,pi_Cattle=thet_pi_Cattle,
     moy_Robel=thet_moy_Robel, sd_Robel=thet_sd_Robel)
  P0=compute_P0(thet); print(round(thet_N,3)); print(round(P0,3))

  # -- start manipulation of hessian
  SIGtheta <- ginv(ss1$hessian); l=length(thetaM)
  if(min(Re(eigen(SIGtheta)$values))<=0) {
    cat('***inverse of hessian has negative eigenvalue...\n')
    cat('     using decomposition and rounding error correction\n')
    SIGtheta=ginv(ss1$hessian+diag(max(-eigen(ss1$hessian)$values,0),l))+diag(1e-6,l)
  }
  e <- eigen(SIGtheta); V <- e$vectors;
  B <- V %*% diag(sqrt(e$values)) %*% t(V); SIGtheta <- Re(B %*% t(B))
  # -- end manipulation of hessian

  z<-NULL; for(s in 1:NS) z<-c(z,thet_beta[s,1:NT[s]])
  xest<- c( z,
    plogis(thet_phi_site+thet_phi_Robel*thet_moy_Robel),
    plogis(thet_phi_site+thet_phi_Stage+thet_phi_Robel*thet_moy_Robel),
    plogis(thet_phi_site+thet_phi_Cattle+thet_phi_Robel*thet_moy_Robel),
    plogis(thet_phi_site+thet_phi_Stage+thet_phi_Cattle+thet_phi_Robel*thet_moy_Robel),
    plogis(thet_p_site+thet_p_Stage+thet_p_Robel*thet_moy_Robel),
    plogis(thet_p_site+thet_p_Robel*thet_moy_Robel),
    plogis(thet_p_site+thet_p_Stage+thet_p_Cattle+thet_p_Robel*thet_moy_Robel),
    plogis(thet_p_site+thet_p_Cattle+thet_p_Robel*thet_moy_Robel),
    thet_N, P0 , thet_phi_Robel,thet_p_Robel
  )

# Bootstrap
cat('\nRunning bootstrap...\n')
x_boot=matrix(0,UUU,length(xest))
for (uuu in 1:UUU) {      #setTkProgressBar(pb,label="Boostrap...",500+uuu)
  #  draw from multivariate distribution
  #--------------------------------------------------
  theta1<-rmvnorm(1,thetaM,SIGtheta); theta=thta.fn(theta1)
  thet_beta<-matrix(0,nrow=NS,ncol=max(NT));i=0
  for (ss in 1:NS) {
    thet_beta[ss,1:NT[ss]]=invlogitgen(theta[i+1:(NT[ss]-1)])
    i=i+NT[ss]-1
  }
  thet_phi_site     =theta[i+1:NS]
  i=i+NS+1; thet_phi_Stage  =theta[i]
  i=i+1; thet_phi_Cattle  =theta[i]
  i=i+1; thet_phi_Robel  =theta[i]
  thet_p_site    =theta[i+1:NS]
  i=i+NS+1; thet_p_Stage    =theta[i]
  i=i+1; thet_p_Cattle  =theta[i]
  i=i+1; thet_p_Robel  =theta[i]
  thet_N          =CC+exp(theta[i+1:NS])
  i=i+NS; thet_pi_Cattle  =plogis(theta[i+1:NS])
  i=i+NS+1; thet_moy_Robel=theta[i]
  i=i+1; thet_sd_Robel=abs(theta[i])
  thet=list(beta=thet_beta,
     phi_site=thet_phi_site,phi_Stage=thet_phi_Stage,
     phi_Cattle=thet_phi_Cattle,phi_Robel=thet_phi_Robel,
     p_site=thet_p_site,p_Stage=thet_p_Stage,
     p_Cattle=thet_p_Cattle, p_Robel=thet_p_Robel,
     N=thet_N,pi_Cattle=thet_pi_Cattle,
     moy_Robel=thet_moy_Robel, sd_Robel=thet_sd_Robel)
  P0=compute_P0(thet)
  z<-NULL; for(s in 1:NS) z=c(z,thet_beta[s,1:NT[s]])
  x_boot[uuu,]<- c(z,
    plogis(thet_phi_site+thet_phi_Robel*thet_moy_Robel),
    plogis(thet_phi_site+thet_phi_Stage+thet_phi_Robel*thet_moy_Robel),
    plogis(thet_phi_site+thet_phi_Cattle+thet_phi_Robel*thet_moy_Robel),
    plogis(thet_phi_site+thet_phi_Stage+thet_phi_Cattle+thet_phi_Robel*thet_moy_Robel),
    plogis(thet_p_site+thet_p_Stage+thet_p_Robel*thet_moy_Robel),
    plogis(thet_p_site+thet_p_Robel*thet_moy_Robel),
    plogis(thet_p_site+thet_p_Stage+thet_p_Cattle+thet_p_Robel*thet_moy_Robel),
    plogis(thet_p_site+thet_p_Cattle+thet_p_Robel*thet_moy_Robel),
    thet_N, P0 , thet_phi_Robel,thet_p_Robel
  )
}

#Display
cat('\n\n###################### RESULTS ################################\n\n')
cat('Untransformed estimates\n')
betase=thta.fn(sqrt(diag(SIGtheta))); theta=thta.fn(thetaM)
tabun<-cbind(theta,theta-1.96*betase,theta+1.96*betase)
dimnames(tabun) <- list(v1,c('estimate','95%CI low','95%CI upp'))
print(round(tabun,3))
cat('\nTransformed estimates\n')
lowb<-apply(X=x_boot, MARGIN=2, FUN =CIlow)
uppb<-apply(X=x_boot, MARGIN=2, FUN =CIhigh)
tab<-cbind(xest,lowb,uppb)
dimnames(tab) <- list(v2,c('estimate','95%CI low','95%CI upp'))
print(round(tab,3))

cat('\nfinal LogLike     =',-ss1$minimum,'\n')
cat('number of parameters=',length(theta_init),'\n')
cat('AIC                 =',2*ss1$minimum+2*length(theta_init),'\n\n')
tt=sum(c(t0[1],t1[1],t2[1]))
cat('cpu time:',round(tt/60,1),'minutes\n')

save(tab,tabun,ss1,ssMOY,s0,file=paste("nest_abund",mname,".Rdata",sep=''))
names(ss1$estimate)=v1[unique(pim)]
x=names(ss1); ss1[[length(ss1)+1]]=tab; names(ss1)=c(x,'tab')
return(ss1)
}  # end of TIME_robel()
